from pymongo import MongoClient

# Retrieve the name and address of all employees who work 
# for the "Research" department.

def query(depts,emps):
  query = {}
  query["dname"] = "Research"
  dno = int(list(depts.find(query,{"dno": 1, "_id": 0}))[0]['dno'])
  query = {}
  query['worksFor'] = dno
  es = list(emps.find(query,{"fname": 1, "lname": 1, "address": 1, "_id": 0}))
  result = []
  for e in es:
    result.append([e['fname'],e['lname'],e['address']]) 
  return result

def main():
  client = MongoClient()
  db = client.companyDB
  depts = db.departments
  emps = db.employees
  result = query(depts,emps)
  print('Retrieve the name and address of all employees who work for the "Research" department')
  for x in result:
    print('%10s %10s %30s'%(x[0],x[1],x[2]))

main()
