from pymongo import MongoClient

# List the names of employees who have no dependents.

def query(emps):
  query = {}
  query["dependents"] = {"$exists": False}
  es = list(emps.find(query,{"fname": 1, "lname": 1, "_id": 0}))
  result = []
  for e in es:
    result.append([e['fname'],e['lname']]) 
  return result

def main():
  client = MongoClient()
  db = client.companyDB
  emps = db.employees
  result = query(emps)
  print('List the names of employees who have no dependents.')
  for x in result:
    print('%10s %10s'%(x[0],x[1]))

main()
