from pymongo import MongoClient

# List the names of managers who have at least one dependent.

def query(depts,emps):
  query = {}
  query["manager"] = {"$exists": True}
  ms = list(depts.find(query,{"manager": 1, "_id": 0}))
  result = []
  for m in ms:
    mssn = m['manager']['mssn'] 
    query = {}
    query["ssn"] = mssn
    query["dependents"] = {"$exists": True}
    es = list(emps.find(query,{"fname": 1, "lname": 1, "_id": 0}))
    for e in es:
      result.append([e['fname'],e['lname']]) 
  return result

def main():
  client = MongoClient()
  db = client.companyDB
  depts = db.departments
  emps = db.employees
  result = query(depts,emps)
  print('List the names of managers who have at least one dependent.')
  for x in result:
    print('%10s %10s'%(x[0],x[1]))

main()
