from pymongo import MongoClient
from functools import reduce

# List the names and addresses of employees who work on at least one project 
# located in Houston but whose department has no location in Houston.

def query(projs,depts,emps):
  result = []
  query = {}
  query["plocation"] = "Houston"
  ps = list(projs.find(query,{"pnumber": 1, "_id": 0}))
  houstonProjects = [int(x['pnumber']) for x in ps]
  es = list(emps.find({},{"worksFor": 1,"fname": 1, "lname": 1, "address": 1, "projects": 1, "_id": 0}))
  for e in es:
    dno = int(e["worksFor"])
    ds = list(depts.find({"dno": dno},{"locations": 1, "_id": 0})) 
    dlocs = ds[0]["locations"]
    if "Houston" in dlocs:
      continue
    if not "projects" in e:
      continue
    ps = e["projects"]
    pnums = [int(x["pno"]) for x in ps] 
    if reduce(lambda b,x: b or x in houstonProjects, pnums, False):
      fn = e["fname"]
      ln = e["lname"]
      address = e["address"]
      result.append([fn, ln, address]) 
  return result

def main():
  client = MongoClient()
  db = client.companyDB
  projs = db.projects
  depts = db.departments
  emps = db.employees
  result = query(projs,depts,emps)
  print("List the names and addresses of employees who work on at least one project")
  print("located in Houston but whose department has no location in Houston.")
  for x in result:
    print('%15s %15s %40s'%(x[0],x[1],x[2]))

main()
